/***********************************************************/ 
/* PRACTICA 3 CURSO 2004-05                                */ 
/*                                                         */
/* AUTORES: Enrique del Rio, Sofia Perez y Jesus Albert    */ 
/* PROPOSITO: Utilizacion de TAD Pila en un                */ 
/*            solitario de cartas españolas                */ 
/***********************************************************/

#include <iostream>
#include "pila.h"
#include "carta.h"

using namespace std;

/******************************************/
/* Declaracion de prototipos de funciones */
/******************************************/

//informacion sobre el juego
void Introduccion();     
//crear una baraja española nueva
void BarajaNueva(Pila&);
//barajar
void Barajar (Pila&);
//motor del juego
void Jugar(Pila[]);
//calcular el menor de dos enteros
int menor(int, int);
//visualizar el tapete de la mesa de juego
void MuestraTapete(Pila[]);
//hacer una pausa, espera un caracter
void pausa ();
//presentar un menu para escoger la pila de origen
int MenuOrigen();
//presentar un menu para escoger la pila de destino
int MenuDestino(int);
//invertir los elementos de una pila
Pila InvertirPila (Pila); 
//vaciar una pila�
void VaciarPila (Pila&);
//comprobar si se puede hacer el movimiento de una carta
bool CartaAceptada(Pila[], int, int );

/**********************/
/* PROGRAMA PRINCIPAL */
/**********************/
int main()
{
  Carta c; //Para repartir las cartas
  Pila monton[13]; //Representa los 13 montones de cartas
  //La asignacion de indices a cada monton es el siguiente:
  //0="Baraja", 
  //1..7="Mazo1", "Mazo2", "Mazo3", "Mazo4", "Mazo5", "Mazo6", "Mazo7", 
  //8..11="Bastos", "Copas", "Espadas", "Oros",
  //12="Auxiliar"
  char opcion; //opcion leida por teclado para continuar jugando
  
  Introduccion(); //Explicacion del juego        
  do { //bucle para seguir jugando nuevas partidas
     //antes de empezar una nueva partida todas las pilas deben estar vacias
     for (int i=0; i<=12; i++)
        while (monton[i].Desapilar ());

     //crear la baraja
     BarajaNueva(monton[0]);
     //barajar
     Barajar(monton[0]);
     
     //Distribuir las pilas de trabajo
     
     //Primero coge cartas de la baraja (0), de una en una, 
     //y las pone en cada mazo (1 al 7)
     for (int i=1;i<8;i++)
        if (monton[0].CimaPila (c))
        {
           monton[0].Desapilar();
           monton[i].Apilar (c);
        }
     //Pasa 5 cartas, de una en una, de la baraja y las apila en la auxiliar
     for (int i=0; i<5; i++) 
        if (monton[0].CimaPila (c))
        {
           monton[0].Desapilar ();
           monton[12].Apilar(c);
        }
     
     //Jugar una partida 
     Jugar(monton);
     
     do {
        cout << "1. Otra partida" << endl;
        cout << "0. Abandonar el juego" << endl;
        cout << "Elige opcion: ";
        cin >> opcion;
        cout << endl;
     } while ((opcion!='1') && (opcion!= '0')); 
     
  } while (opcion=='1');

  return 0;
}

/*********************************************/
/* Descripcion: informacion sobre el juego   */
/* Argumentos: NO                            */
/* Salida: NO                                */
/*********************************************/
void Introduccion()
{
  cout<<endl;
  cout<<"=====================================================================\n";
  cout<<"  El juego consiste en mover una carta de una pila a otra hasta no \n";
  cout<<"poder efectuar movimientos validos, no poder extraer cartas de la pila\n";
  cout<<"principal o tener todas las cartas del mismo palo apiladas en cada\n";
  cout<<"pila: bastos, copas, espadas y oros.\n";
  cout<<"  Solo se permite mover a una pila vacia o cuya cima tenga una carta\n";
  cout<<"de distinto palo y cuyo valor sea \n";
  cout<<"   -una unidad inferior para el caso de las pilas de los palos (;-)).\n";
  cout<<"   -una unidad superior para el caso de las pilas de trabajo.\n";
  cout<<"Las pilas vacias se marcan, autom�icamente, con X.\n";           
  cout<<"El juego comienza creando:\n";
  cout<<"   - 7 pilas de trabajo con una carta cada una.\n";
  cout<<"   - 4 pilas vac�s para colocar las cartas de cada palo (bastos,  \n"; 
  cout<<"copas, espadas y oros), comenzando con el As (1) y continuando con el \n"; 
  cout<<"2, 3, etc hasta el Rey (12) segun vayan apareciendo en los sucesivos \n";
  cout<<"descartes o quedando en la cima de cada una de las pilas de trabajo.\n";
  cout<<"  Los descartes del mazo de la baraja se producen creando una pila \n";
  cout<<"auxiliar con las cinco cartas superiores del mazo de la baraja boca \n";
  cout<<"arriba. Si la que se encuentra visible se puede colocar en alguna de \n";
  cout<<"las pilas anteriores se coloca. Se sigue as�con las restantes hasta \n";
  cout<<"llegar a una en que no se pueda.\n";
  cout<<"En este caso, se coge otro grupo de cinco cartas del mazo de la baraja,\n"; 
  cout<<"se colocan encima de las de la pila auxiliar boca arriba y, \n";
  cout<<"si es posible, se van colocando en alguna de las demas pilas.\n";
  cout<<"Se procede asi hasta que se agotan las cartas del mazo de la baraja \n";
  cout<<"en cuyo caso, se repite el proceso volcando la pila auxiliar sobre \n";
  cout<<"la baraja.\n";
  cout<<"=====================================================================\n";
  cout<<endl;
}

/**********************************************************/
/* Descripcion: Crea una baraja española nueva (ordenada) */
/* Argumentos: Pila que se va a modificar                 */
/* Salida: La misma pila                                  */
/**********************************************************/
void BarajaNueva(Pila& baraja)   
{
   Carta c; //para crear las cartas de la baraja
   char palo; //identifica los palos de la baraja
   bool fin = false; //flag de final
 
   palo = 'O'; //empezamos por los oros
   while (!fin) //recorre todos los palos
   {
      //para cada palo crea sus 12 cartas
      for(int i = 1; i <= 12; i++)
      {
         c.ponerCarta(palo,i); 
         baraja.Apilar (c);
      }
      //pasa al siguiente palo
      switch (palo)
      {
         case 'O': palo = 'C'; break;
         case 'C': palo = 'E'; break;
         case 'E': palo = 'B'; break;
         case 'B': fin = true;
      }
   }
}

/******************************************/
/* Descripcion: Barajar                   */
/* Argumentos: Pila que se va a modificar */
/* Salida: La misma pila                  */
/******************************************/
void Barajar (Pila& b)
{
   int numero; //para generar numeros aleatorios
   Carta aux; //para realizar intercambios
   Carta v[48]; //vector auxiliar de cartas
   
   //Volcar los datos de la pila en el vector auxiliar v
   for (int i=0;i<48;i++)
   {
      b.CimaPila(v[i]);
      b.Desapilar();
   }   
   //para fin = 47 hasta 1 hacer
   //pos = generar un nº aleatorio entre 0 y fin
   //intercambiar los elementos v[pos] y v[fin]
   srand(time(NULL));
   for(int fin=47; fin>=0; fin--)
   {
      numero = rand()%(fin+1);
      aux = v[numero];
      v[numero]= v[fin];
      v[fin] = aux;
   }
   //Volcar de nuevo los datos de v en la pila
   for (int i=0;i<48;i++)
      b.Apilar(v[i]);     
}

/**********************************************************/
/* Descripcion: Motor del juego                           */
/* Argumentos: Array de pilas que representa los montones */
/* Salida: NO                                             */
/**********************************************************/
void Jugar(Pila m[13])
{
   int origen, destino; //origen y destino de los movimientos de cartas
   int n;
   bool fin; //flag para indicar el final del juego
   Carta c; //carta que se mueve en cada paso del juego
   
   fin = false;
   while (!fin) //Repetir jugadas hasta que finalice la partida
   {               
      //Visualizar estado de las pilas
      MuestraTapete(m);      
      //Seleccionar origen del movimiento
      origen=MenuOrigen(); 
      //Comprobar la seleccion de origen
      if (origen != 14) //14 = Salir del juego
      {
         if (!m[origen].PilaVacia()) //Solo si el origen tiene cartas se puede mover
	 {
	    if ( (origen>=1) && (origen<=12) )
	    //pila origen es una de las pilas de trabajo, palos o auxiliar
	    {
               //Escoge una pila de destino
	       destino=MenuDestino(origen);
	       if (destino!=15) //15 anular el movimiento
	       {
	          while ( (destino<=14) && (!CartaAceptada (m,origen,destino)) )
	          {
                     //Repite hasta que la carta se puede apilar en la pila de trabajo segun las reglas
                     cout<<"La carta no se puede poner en esa pila.\n";
                     cout<<"Escoge otra pila o \"sal\" para escoger otra carta"<<endl;
                     destino=MenuDestino(origen);
                  }
                  //Una vez asegurado de que se puede dejar la carta en la pila de destino, desapila 
                  //la quita de la pila de origen y la deja en la pila destino   
                  if(destino==14)
		     fin = true;
		  else
		     if (destino !=15)
                     {
		        m[origen].CimaPila (c);
                        m[origen].Desapilar ();
                        m[destino].Apilar (c);   
                     }
		}
	    }
	    else
	       //es un movimiento especial, sacar mas cartas de la baraja o
	       //volcar el monton auxiliar en la baraja
               if (origen == 0)
               {
                  //Si se escoge descartar, se deben pasar 5 cartas de la baraja  
                  //a la pila Auxiliar dejandolas en el orden en que van llegando,
                  //todas, si tiene menos de cinco
		  n = menor(5,m[0].NElementosPila());
                  for (int i=1; i<=n; i++)
                     if (m[0].CimaPila (c))
                     {
                        m[0].Desapilar();
                        m[12].Apilar (c);
                     }
               }
	       else //caso 13
               {
	          if (m[0].PilaVacia())
		  {
		     //Volcar la pila auxiliar en la Baraja
		     //solo si la baraja esta vacia
                     m[0]=InvertirPila(m[12]); 
                     //Vaciar la pila Auxiliar
                     VaciarPila(m[12]); 
		  }
		  else //la baraja no esta vacia
		    cout << "Movimiento no valido. La baraja tiene cartas." << endl;
               }
         }
      }
      else //seleccionado finalizar partida
         fin = true;
      //El juego finaliza si los montones de los palos estan completos
      if ( (m[8].NElementosPila()==12) && (m[9].NElementosPila()==12) && (m[10].NElementosPila()==12) && (m[11].NElementosPila()==12) )
      {
         cout << "Enhorabuena, has finalizado la partida con exito." << endl;
	 fin = true;
      }
   }//final while
} 

/*************************************************/
/* Descripcion: Devuelve el menor de dos enteros */
/* Argumentos: Los enteros a comparar            */
/* Salida: El entero menor                       */
/*************************************************/
int menor(int a, int b)
{
    if (a>=b) return b;
    else return a;
}

/************************************************************************************/
/* Descripcion: Presenta el tapete de la mesa de juego con cada pila en la posicion */
/* correspondiente y las cartas que hay en cada una de ellas.                       */
/* Argumentos: Array de pilas que representa los montones                           */
/* Salida: NO                                                                       */
/************************************************************************************/
void MuestraTapete(Pila m[13])
{
   string nombreMonton[13]={"Baraja", "Mazo1", "Mazo2", "Mazo3", "Mazo4", "Mazo5", "Mazo6", "Mazo7", "Bastos", "Copas", "Espadas", "Oros", "Auxiliar"}; //Nombres para visualizar los montones
   
   cout<<"Tapete"<<endl;
   cout<<"=================================================="<<endl;
   //Muestra las pilas de los palos
   for (int i=8;i<12;i++) 
   {
      cout<<"Pila " << nombreMonton[i] << ": ";
      m[i].MostrarPila();
      cout<<endl;
   }
   cout<<"--------------------------------------------------"<<endl;  
   //Muestra las pilas de trabajo (mazos)
   for (int i=1;i<8;i++) 
   {
      cout<<"Pila " << nombreMonton[i] << ": ";
      m[i].MostrarPila();
      cout<<endl;
   }
   //Muestra la pila auxiliar
   cout << "Pila " << nombreMonton[12] << ": "; 
   m[12].MostrarPila();
   cout<<endl;
   cout<<"=================================================="<<endl;
   //Muestra la baraja
   cout << "Pila " << nombreMonton[0] << ": "; 
   m[0].MostrarPila();
   cout<<endl;
   pausa();
}

/****************************************************/
/* Descripcion: Hacer una pausa, espera un caracter */
/* Argumentos: NO                                   */
/* Salida: NO                                       */
/****************************************************/
void pausa ()
{
   cout << "Pulsar <enter>" << endl;
   cin.ignore();cin.ignore();
}

/****************************************************************/
/* Descripcion: Presenta un menu para escoger la pila de origen */
/* cuando se quiere mover una carta durante el juego.           */
/* Argumentos: NO                                               */
/* Salida:                                                      */
/*        1..7 montones de trabajo                              */
/*        8..11 montones de palos                               */
/*        12 auxiliar                                           */
/*        0 sacar 5 cartas de la baraja                         */
/*        13 volcar auxiliar en baraja                          */
/*        14 salir del juego                                    */
/****************************************************************/
int MenuOrigen(void)
{
   bool final; //controla la seleccion de opciones validas
   char opcion; //opcion seleccionada
   int indice; //indice del array de pilas que corresponde con la seleccion (salida)
     
   do {
      cout << "Elige una pila de origen, sacar 5 cartas de la baraja o\n"; 
      cout << "volcar la auxiliar en la baraja\n";
      cout << "=========================\n";
      cout << "B ............ Bastos\n";
      cout << "C ............ Copas\n";
      cout << "E ............ Espadas\n";
      cout << "O ............ Oros\n";
      cout << "1 ............ Mazo1\n";
      cout << "2 ............ Mazo2\n";
      cout << "3 ............ Mazo3\n";
      cout << "4 ............ Mazo4\n";
      cout << "5 ............ Mazo5\n";
      cout << "6 ............ Mazo6\n";
      cout << "7 ............ Mazo7\n";
      cout << "A ............ Auxiliar\n";
      cout << "-----------------------------------------------\n";
      cout << endl;
      cout << "D ............ Sacar 5 cartas de la baraja\n";
      cout << "V ............ Volcar auxiliar en la baraja\n";
      cout << endl;
      cout << "Opcion (S/s para dejar el juego): ";
      cin >> opcion;
      cout << endl;
          
      final = true;
      //Pilas de trabajo 1 a 7
      if ( (opcion>='1') && (opcion<='7') )
         indice = int(opcion)-int('0');//opcion como int
      else //Resto de opciones
         switch (opcion)
         {
            //Pila Bastos
            case 'B': case 'b':
               indice=8; break;
            //Pila Copas
            case 'C': case 'c':
               indice=9; break;
            //Pila Espadas
            case 'E': case 'e':
               indice=10; break;
            //Pila Oros
            case 'O': case 'o':
               indice=11; break;
            //Pila Auxiliar
            case 'A': case 'a':
               indice=12; break;
            //Para descartar la baraja
            case 'D': case 'd':
               indice=0; break;
            //devuelve las cartas de la pila Auxiliar a la Baraja
            case 'V': case 'v':
               indice=13; break;
            //Para salir del juego     
            case 'S': case 's':
               indice=14; break;
            default: 
               final=false; break;
         }
   } while (!final); //final solo es falso si la opcion no es valida
   return (indice);
}

/*****************************************************************/
/* Descripcion: Presenta un menu para escoger la pila de destino */
/* cuando se quiere mover una carta durante el juego.            */
/* Argumentos: NO                                                */
/* Salida:                                                       */
/*        1..7 montones de trabajo                               */
/*        8..11 montones de palos                                */
/*        14 salir del juego                                     */
/*        15 anular el movimiento                                */
/*****************************************************************/
int MenuDestino(int origen)
{
   bool final; //controla la seleccion de opciones validas
   char opcion; //opcion seleccionada
   int indice; //indice del array de pilas que corresponde con la seleccion (salida)
     
   //En las opciones Descartar (D)-->origen=0, devolver las cartas a la baraja (V)-->13,
   //y salir (S)-->14, no hay que indicar pila de destino. La pila auxiliar no es un destino.
   if(origen!=14 || origen!=13 || origen!=0)
      do {
         cout << "Elige una pila de destino\n";
         cout << "B ............ Bastos\n";
         cout << "C ............ Copas\n";
         cout << "E ............ Espadas\n";
         cout << "O ............ Oros\n";
         cout << "1 ............ Mazo1\n";
         cout << "2 ............ Mazo2\n";
         cout << "3 ............ Mazo3\n";
         cout << "4 ............ Mazo4\n";
         cout << "5 ............ Mazo5\n";
         cout << "6 ............ Mazo6\n";
         cout << "7 ............ Mazo7\n";
         cout << "-----------------------------------------------\n";
         cout << endl;
         cout << "X ............ Anular la jugada\n";
         cout << endl;
         cout << "Opcion (S/s para dejar el juego): ";
         cin >> opcion;
         cout << endl;
        
         final = true;
         //Pilas de trabajo 1 a 7
	 if ( (opcion>='1') && (opcion<='7') )
            indice = int(opcion)-int('0');//opcion como int
	 else //Resto de opciones
            switch (opcion)
            {
               //Pila Bastos
               case 'B': case 'b':
                    indice=8; break;
               //Pila Copas
               case 'C': case 'c':
                    indice=9; break;
               //Pila Espadas
               case 'E': case 'e':
                    indice=10; break;
               //Pila Oros
               case 'O': case 'o':
                    indice=11; break;
               //Para salir del juego     
               case 'S': case 's':
                    indice=14; break;
               case 'X': case 'x':
	            indice=15; break;
               default:
                    final=false; break;
           }	   
       } while (!final);  //final solo es falso si la opcion no es valida
   return (indice);
}

/**********************************************************/
/* Descripcion: Invierte los elementos de una pila        */
/* Argumentos: Pila                                       */
/* Salida: Nueva Pila con los datos de entrada invertidos */
/**********************************************************/
Pila InvertirPila (Pila p)
{
   Pila aux; //pila nueva donde se invierten los elementos
   Carta c; //para extraer las cartas de la pila
   
   while (p.CimaPila(c))
   {
      aux.Apilar(c);
      p.Desapilar();
   }
   return aux;
}

/*************************************************/
/* Descripcion: Vaciar una pila�                 */
/* Argumentos: Pila                              */
/* Salida: Deja la pila de entrada sin elementos */
/*************************************************/
void VaciarPila (Pila& p) //
{
     while (p.Desapilar());
}

/**************************************************************************/
/* Descripcion: Comprobar si se puede hacer el movimiento de una carta    */
/* Argumentos: Array de montones, indice del monton origen y del destino  */
/* Salida: bool, true = movimiento valido, false = movimiento no aceptado */
/**************************************************************************/
bool CartaAceptada(Pila m[13], int org, int des)
{
   Carta c_org, c_des; //cartas (cima) de los montones origen y destino
   bool trabajo; //indica si el destino es un mazo de trabajo o no (monton de palos)
   bool aceptada; //aceptado el movimiento o no (salida)

   //De entrada, el movimiento no se acepta.
   //Solo si cumple las reglas del juego se aceptara.
   aceptada = false;
   
   //obtener la carta que se desea mover
   m[org].CimaPila (c_org);
   //Comprobar el tipo de destino
   if ( (des>=1) && (des<=7) ) //pilas de trabajo
      trabajo = true;
   else //pilas de palos
      trabajo = false;

   //Verificar reglas de movimiento	 
   if (trabajo) //pilas de trabajo
      if (m[des].PilaVacia()) //si esta vacia se acepta cualquier carta
         aceptada = true;
      else //palo diferente y una unidad inferior
      {
         if (m[des].CimaPila(c_des))
            if ( (c_org.paloCarta()!=c_des.paloCarta()) && (c_org.numeroCarta() == c_des.numeroCarta()-1) )
	       aceptada = true;
      }
   else //pilas de palos
      if ( (m[des].PilaVacia()) && (c_org.numeroCarta()==1) )
      //si la pila esta vacia debe de ser un as del mismo palo
         switch (c_org.paloCarta())
	 {
	    case 'B':
	       if (des==8) aceptada = true; break;
	    case 'C':
	       if (des==9) aceptada = true; break;       
	    case 'E':
	       if (des==10) aceptada = true; break;	       
	    case 'O':
	       if (des==11) aceptada = true; break;	       
	 }
      else //mismo palo y una unidad superior
          if (m[des].CimaPila(c_des))
            if ( (c_org.paloCarta()==c_des.paloCarta()) && (c_org.numeroCarta() == c_des.numeroCarta()+1) )
	       aceptada = true;
	       
   return aceptada;
}

   
